#include "qLab/qMath.lsl"

list __qDynaPrims;
float __qDynaRadius = 0;
integer __qDynaCount = 10;
vector __qDynaOrigin;


qDynaSetOrigin(vector o)
{
  __qDynaOrigin = o;
}

qDynaSetRadius(float r)
{
  __qDynaRadius = r;
}

qDynaSetCount(integer c)
{
  __qDynaCount = c;
}

integer qDynaRez()
{
  while(llGetListLength(__qDynaPrims) < __qDynaCount)
    {
      integer com = (integer)qRandom(10000, 10000000);

      vector place = (__qDynaOrigin +
		      __qDynaRadius * llVecNorm(<llFrand(2.0) - 1, 
						llFrand(2.0) - 1, 
						llFrand(2.0) - 1>));

      llRezObject("qDynaPrim", llGetPos() + place,
		  <0,0,0>, ZERO_ROTATION, com);

      // llSleep(1);

      __qDynaPrims = __qDynaPrims + [ com ];

    }

  integer front = llList2Integer(__qDynaPrims, 0);

  __qDynaPrims = llDeleteSubList(__qDynaPrims, 0, 0);

  return front;
}


qDynaCleanup()
{
  llSleep(10);
  while (llGetListLength(__qDynaPrims) > 0)
    {
      integer com = llList2Integer(__qDynaPrims, 0);
      llSay(com, "prim -die");
      __qDynaPrims = llDeleteSubList(__qDynaPrims, 0, 0);
    }
}

